	function toJson(obj)
	{
		if(!obj)
			return null;
		var pars = [];
		for(var i in obj)
		{
			var type = typeof(obj[i]);
			if(type != "function")
			{
				if(type == "object")
					pars.push( "\"" + i+"\": "+toJson(obj[i]) );
				else
				{
					var item = obj[i];
					if(item && item.replace)
						item = '"'+item.replace(/"/g, '\"')+'"';
					pars.push( "\"" + i + "\": "+item );
				}
			} 
		}
		return "{"+ pars.join(", ") +"}";
	};
	
	function js2php(obj, path, new_path)
	{
		var exceptions = ["$family"];
		if (typeof(path) == 'undefined') var path=[];
		if (typeof(new_path) != 'undefined') path.push(new_path);
		var post_str = [];
		if(!obj)
			obj = '';
		if (typeof(obj) == 'array' || typeof(obj) == 'object')
		{
			for (var n in obj)
				if(typeof(n) != "function" && $jQ.inArray(n, exceptions) == -1)
	 				post_str.push(js2php(obj[n], path, n));
		}
		else if (typeof(obj) != 'function')
		{
			var base = path.shift();
			post_str.push(base + (path.length > 0 ? '[' + path.join('][') + ']' : '') + '=' + rawEscape(obj));
			path.unshift(base);
		}
		path.pop();
		return post_str.join('&');
	};

	function rawEscape(str)
	{
		str = escape(str);
		return str.replace(/\+/g, '%2B');		
	};

	function copyToClipBoard(elt)
	{
		if(window.ie6)
			return;
		var urlSwf = "/js/_clipboard.swf";
		var strMssgBoxId = "notifyTextCopied";
		var eltNotify = null;
		var flashcopier = 'flashcopier';
		elt = $(elt);

		// Display Notifications
		if((eltNotify = $(strMssgBoxId)) == null){
			// Attach the notification to the DOM
			eltNotify = new Element('div', {id: strMssgBoxId, styles: {opacity: 0, position: 'absolute'}});
			eltNotify.innerHTML = 'Copied';
			eltNotify.injectInside(document.body);
		}
		elt.onblur = function(e){
			eltNotify.setStyle('display', 'none');
			return true;
		};
		var ps = elt.getPosition();
		eltNotify.setStyles({display: 'block', top: ps.y-elt.offsetHeight, left: ps.x+Math.round(elt.offsetWidth/2)-25});
		if(!eltNotify.fx)
			eltNotify.fx = new Fx.Tween(eltNotify, {property: "opacity", fps: 30, wait: false});

		eltNotify.fx.options.duration = 100;
		eltNotify.fx.start(0, 1).chain(function(){ this.options.duration = 2000; this.start.delay(500, this, 0)});
		// Copy the text inside the text box to the user's clipboard
		if(!$(flashcopier)){
			var divholder = new Element('div', {id: flashcopier});
			divholder.injectInside(document.body);
		}
		$(flashcopier).innerHTML = '';
		var divinfo = '<embed src="' + urlSwf + '" FlashVars="clipboard='+escape(elt.value)+'" width="0" height="0" type="application/x-shockwave-flash"></embed>';
		$(flashcopier).innerHTML = divinfo;
		window.status = 'Copied text to clipboard';
		elt.select();
		return true;
	};

	PlaceAjaxIcon = function(Obj)
	{
		if(!Obj)
			return;
		Obj = $jQ(Obj); 
		var Ico = $jQ('<img src="' + G_PS_Path + '/img/ajaxloader.gif" />');
		var Par = Obj.parent(); 
		var Pos = Obj.position();
		Ico.css({position: "absolute", top: Pos.top+3, left: Pos.left+Obj.get(0).offsetWidth+4});
		Par.append(Ico);
		return Ico;
	};
	
	Validation = function()
	{
		// empty value check
		this.checkEmpty = function(Fld)
		{
			if(!Fld.val().length || Fld.get(0).disabled)
				return false;
			return true;
		};
		this.checkBlank = function(Fld)
		{
			if(!Fld.val().length || Fld.get(0).disabled)
				return false;
			if(!Fld.val().replace(/[ \\r\\n]/g, ''))
				return false;
			return true;
		};
		this.checkSize = function(Fld, From, To)
		{
			if(Fld.val().length < From || Fld.val().length > To)
				return false;
			return true;
		};
		this.checkText = function(Fld)
		{
			if(Fld.val().match(/[a-z0-9\.\",\-_' ><\?\!\*\^\%\@\$\&\^\(\)\{\}\[\]\+\=\&\:]*/gi)[0] != Fld.val())
				return false;
			return true;
		};
	};

	
	GreenArrow = function(text, width, top, left, container)
	{
		this.width = width;	this.top = top;	this.left = left; this.container = container;
		this.create(text);
	};
	GreenArrow.prototype.create = function(text)
	{
		this.main = new Element("div", {"class": "g-green-arrow", styles: {top: this.top, left: this.left}});
		this.main.injectInside(this.container?this.container:this.document.body);
		new Element("div", {"class": "left"}).injectInside(this.main);
		this.text = new Element("div", {"class": "text", styles: {width: this.width}}).injectInside(this.main);
		this.text.innerHTML = text;
		new Element("div", {"class": "right"}).injectInside(this.main);
		this.fx = new Fx.Tween(this.main, {property: "opacity", duration:200, fps:30, wait: false}); 
		this.show();
	};
	GreenArrow.prototype.show = function()
	{
		this.main.setStyle("display", "block");
		this.fx.start(1);
	};
	GreenArrow.prototype.hide = function()
	{
		var that = this;
		this.fx.start(0).chain(function (){ that.main.setStyle("display", "none") });
	};

	/*
	 * Singleton object with notification box functionality
	 */
	var Noter = new function()
	{
		var that = this;
		var _Width = 350;
		var _Timer = null;
		var _Box = $jQ('<div class="b-noter"></div>');
		var _Cnt = $jQ('<div class="notes"></div>').appendTo(_Box);
		this.ShownMsgs = [];
		$jQ(window).ready(function()
		{
			_Box.appendTo(document.body);
			var Sz = $jQ.winSize();
			_Box.origPos = [(Sz.Sz.X-_Width)/2, 0];
			_Box.css({width: _Width, left: (Sz.Sz.X-_Width)/2});
		});
		var hide = function()
		{
			_Box.fadeOut(1000, function()
			{
				that.ShownMsgs = [];
				_Box.css("display", "none");
				_Cnt.html("");
				if(_Box.onhide)
					_Box.onhide();
			});
		};
		this.display = function(Msg, Type, Action)
		{
			var A = null;
			if(!Type)
				Type = "";
			if($jQ.inArray(Msg, this.ShownMsgs) == -1)
			{
				var D = null;
				if(Type.search("repl_")!=-1)
					D = _Cnt.find("."+Type);
				if(!D || !D.get(0))
					D = $jQ('<div class="' + Type + '"></div>').appendTo(_Cnt);
				else
					this.ShownMsgs = $jQ.grep(this.ShownMsgs, function(N, I){ return N != D.get(0).Msg }); 
				D.html(Msg + " ");
				D.get(0).Msg = Msg;
				this.ShownMsgs.push(Msg);
			}
			else if(Action)
			{
				if(_Box.onhide)
					_Box.onhide();
				A = _Cnt.find("."+Type).find("a");
			}
			_Box.css({left: _Box.origPos[0], top: _Box.origPos[1]});
			_Box.get(0).scrollIntoView();
			if(Action)
			{
				_Box.onhide = Action.fina;
				if(Action.Name)
				{
					if(!A)
					{
						A = $jQ('<a href="#"></a>').appendTo(D); 
						A.html(Action.Name);
					}
					A.click(function()
					{
						window.clearTimeout(that._Timer);
						_Box.onhide = null;
						Action.func();
						hide();
						return false;
					});
				}
			}
			_Box.css("display", "block");
			_Box.fadeIn(100);
			if(this._Timer)
				window.clearTimeout(this._Timer);
			this._Timer = window.setTimeout(hide, 3000);
		};
		return this;
	}();
	
	var Validator = new Validation();